//+------------------------------------------------------------------+
//|                                        dynamic balance point.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern int dbpLength = 5;

//
//
//
//
//

double dbp[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    SetIndexBuffer(0,dbp);
      dbpLength = MathMax(1,dbpLength);

   //
   //
   //
   //
   //
   
   IndicatorShortName("Dynamic balance point ("+dbpLength+"- weekly )");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      int k       = iBarShift(NULL,0,Time[i]-dbpLength*PERIOD_W1*60);
      int weekDay = TimeDayOfWeek(Time[i]);
      for (; k<Bars; k++)
      {
         if (TimeDayOfWeek(Time[k]) != weekDay) break;
      }
         
      int x = k-1;
      int l = x-i+1;
         
         double hi = High[iHighest(NULL,0,MODE_HIGH,l,i)];
         double lo = Low[iLowest(NULL,0,MODE_LOW,l,i)];

      //
      //
      //
      //
      //
      
      dbp[i] = (hi+lo+Close[i])/3.0;
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}